/**
 * mainframe.js
 */
var baseUrl = '';
var theme = '';
var viewAlarmType,pieAlarmType,statusType;
Ext.Loader.setConfig({
    enabled: true
});

Ext.Loader.setPath('Ext.ux', '../../res/extjs/examples/ux');
Ext.require([
	  'Ext.panel.Panel',
	  'Ext.button.Button',
	  'Ext.window.Window',
	  'Ext.ux.statusbar.StatusBar',
	  'Ext.toolbar.TextItem',
	  'Ext.menu.Menu',
	  'Ext.toolbar.Spacer',
	  'Ext.button.Split',
	  'Ext.form.field.TextArea',
	  'Ext.util.TaskRunner'
	]);

var task = {   
	    run : function() { 
	    	Ext.getCmp('timestamp_bar').setValue(Ext.Date.format(new Date(), 'Y-m-d H:i:s'));
	    },   
	    interval : 1000   
	};


var setCompanyCode = function(id){
	$("#company_code").val(id);
}

var subAlarm = Ext.create('Ext.menu.Menu',{
	items:[
		{
			text : '火灾监控',
			cls:'usky_menu',
			iconCls : 'menu_fire_btn',
			disabled:($("#V_LOGINNAME").val()=='guest'),
			handler: function() {
				var div = document.getElementById('main_center_layout');
				try{
					div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/fireAlarm/subFireAlarm.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
				}catch(e){}
			}
		},{
			text : '电气火灾监控',
			cls:'usky_menu',
			iconCls : 'menu_efire_btn',
			disabled:($("#V_LOGINNAME").val()=='guest'),
			handler: function() {
				var div = document.getElementById('main_center_layout');
				try{
					div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/efireAlarm/subeFireAlarm.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
				}catch(e){}
			}
		},{
			text : '消防水系统监控',
			cls:'usky_menu',
			iconCls : 'menu_water_btn',
			disabled:($("#V_LOGINNAME").val()=='guest'),
			handler: function() {
				var div = document.getElementById('main_center_layout');
				try{
					div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/waterAlarm/subWaterAlarm.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
				}catch(e){}
			}
		},{
			text : 'RTU综合监控',
			cls:'usky_menu',
			iconCls : 'menu_efire_btn',
			disabled:($("#V_LOGINNAME").val()=='guest'),
			handler: function() {
				var div = document.getElementById('main_center_layout');
				try{
					div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/rtuAlarm/subRtuAlarm.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
				}catch(e){}
			}
		}
	]
});

var subDevice = Ext.create('Ext.menu.Menu',{
	items:[
		{
			text : '火灾监控',
			cls:'usky_menu',
			iconCls : 'menu_fire_btn',
			disabled:($("#V_LOGINNAME").val()=='guest'),
			handler: function() {
				var div = document.getElementById('main_center_layout');
				try{
					div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/fireAlarm/FireDeviceIndex.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
				}catch(e){}
			}
		},{
			text : '电气火灾监控',
			cls:'usky_menu',
			iconCls : 'menu_efire_btn',
			disabled:($("#V_LOGINNAME").val()=='guest'),
			handler: function() {
				var div = document.getElementById('main_center_layout');
				try{
					div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/efireAlarm/eFireDeviceIndex.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
				}catch(e){}
			}
		},{
			text : '消防水系统监控',
			cls:'usky_menu',
			iconCls : 'menu_water_btn',
			disabled:($("#V_LOGINNAME").val()=='guest'),
			handler: function() {
				var div = document.getElementById('main_center_layout');
				try{
					div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/waterAlarm/WaterDeviceIndex.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
				}catch(e){}
			}
		},{
			text : 'RTU综合监控',
			cls:'usky_menu',
			iconCls : 'menu_efire_btn',
			disabled:($("#V_LOGINNAME").val()=='guest'),
			handler: function() {
				var div = document.getElementById('main_center_layout');
				try{
					div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/rtuAlarm/RtuDeviceIndex.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
				}catch(e){}
			}
		}
	]
});

var subData = Ext.create('Ext.menu.Menu',{
	items:[
		{
			text : '电气火灾数据查询',
			cls:'usky_menu',
			iconCls : 'menu_fire_btn',
			disabled:($("#V_LOGINNAME").val()=='guest'),
			handler: function() {
				var div = document.getElementById('main_center_layout');
				try{
					div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/dataSearch/fireIndex.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
				}catch(e){}
			}
		},{
			text : '消防水系统数据查询',
			cls:'usky_menu',
			iconCls : 'menu_water_btn',
			disabled:($("#V_LOGINNAME").val()=='guest'),
			handler: function(){
				var div = document.getElementById('main_center_layout');
				try{
					div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/dataSearch/index.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
				}catch(e){}
			}
//			handler: function() {
//				var div = document.getElementById('main_center_layout');
//				try{
//					div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/waterAlarm/WaterDeviceIndex.jsp?theme='+theme+'"></iframe>';
//				}catch(e){}
//			}
		},{
			text : 'RTU综合数据查询',
			cls:'usky_menu',
			iconCls : 'menu_efire_btn',
			disabled:($("#V_LOGINNAME").val()=='guest'),
			handler: function() {
				var div = document.getElementById('main_center_layout');
				try{
					div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/dataSearch/rtuIndex.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
				}catch(e){}
			}
		}
	]
});

var routData = Ext.create('Ext.menu.Menu',{
	items:[
		{
			text : '巡检计划',
			cls:'usky_menu',
			iconCls : 'menu_fire_btn',
			handler: function() {
				var div = document.getElementById('main_center_layout');
				try{
					div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/patrolplan/index.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
				}catch(e){}
			}
		},{
			text : '巡检点位',
			cls:'usky_menu',
			iconCls : 'menu_fire_btn',
			handler: function() {
				var div = document.getElementById('main_center_layout');
				try{
					div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/patrolpoint/index.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
				}catch(e){}
			}
		},{
			text : '巡检路线',
			cls:'usky_menu',
			iconCls : 'menu_fire_btn',
			handler: function() {
				var div = document.getElementById('main_center_layout');
				try{
					div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/route/index.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
				}catch(e){}
			}
		},{
			text : '巡检记录',
			cls:'usky_menu',
			iconCls : 'menu_fire_btn',
			handler: function() {
				var div = document.getElementById('main_center_layout');
				try{
					div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/checkrecord/index.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
				}catch(e){}
			}
		},{
			text : '巡检点操作记录',
			cls:'usky_menu',
			iconCls : 'menu_fire_btn',
			handler: function() {
				var div = document.getElementById('main_center_layout');
				try{
					div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/inspectionrecord/index.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
				}catch(e){}
			}
		}
	]
});

var menuMain = Ext.create('Ext.menu.Menu',{
	items: [{
		text : '综合查询',
		cls:'usky_menu',
		iconCls : 'menu_frontpage_btn',
		handler: function(){
			var div = document.getElementById('main_center_layout');
			var type = $("#viewAlarmType").val();
			try{
				div.innerHTML='<iframe id="frame_frontpage" frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/frontpage/map.jsp?viewAlarmType='+viewAlarmType+'&pieAlarmType='+pieAlarmType+'&statusType='+statusType+'&theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
			}catch(e){}
		}
	},{
		text : '告警信息',
		cls:'usky_menu',
		iconCls : 'menu_alarm_btn',
		menu: subAlarm
	},{
		text : '设备监控',
		cls:'usky_menu',
		iconCls : 'menu_device_btn',
		menu: subDevice
	},{
		text : '数据查询',
		cls:'usky_menu',
//		disabled:true,
		iconCls : 'menu_data_btn',
		menu: subData
	},{
		text : '巡检工作',
		cls:'usky_menu',
//		disabled:true,
		iconCls : 'menu_around_btn',
		disabled:($("#V_LOGINNAME").val()=='guest'),
		menu: routData
	},{
		text : '工作考评',
		cls:'usky_menu',
		disabled:true,
		iconCls : 'menu_work_btn'
	}]
});

var menuSub = Ext.create('Ext.menu.Menu',{
	items: [{
		text : '火灾监控',
		cls:'usky_menu',
		iconCls : 'menu_fire_btn',
		disabled:($("#V_LOGINNAME").val()=='guest'),
		handler: function() {
			var div = document.getElementById('main_center_layout');
			try{
				div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/fireAlarm/index.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
			}catch(e){}
		}
	},{
		text : '电器火灾监控',
		cls:'usky_menu',
		iconCls : 'menu_efire_btn',
		disabled:($("#V_LOGINNAME").val()=='guest'),
		disabled: true
	},{
		text : '消防水系统监控',
		cls:'usky_menu',
		iconCls : 'menu_water_btn',
		disabled:($("#V_LOGINNAME").val()=='guest'),
		handler: function() {
			var div = document.getElementById('main_center_layout');
			try{
				div.innerHTML='<iframe frameborder=0 width="100%" height="100%" allowtransparency="true" scrolling=auto src="'+baseUrl+'view/waterAlarm/index.jsp?theme='+theme+($("#company_code").val().length>0?('&company_code='+$("#company_code").val()):'')+'"></iframe>';
			}catch(e){}
		}
	},{
		text : '通道告警监控',
		cls:'usky_menu',
		iconCls : 'menu_access_btn',
		disabled: true
	},{
		text : '消防电源监控',
		cls:'usky_menu',
		iconCls : 'menu_power_btn',
		disabled: true
	},{
		text : 'RTU综合监控',
		cls:'usky_menu',
