/* 
     电气火灾数据对接
*/


//建筑下拉
getNameList();

function getNameList(queryParam = {}) {

    ajaxRequest(GET_NAME_LIST_DATA, "POST", queryParam, function(result) {
        let data = result.RESULT;
        let items = '';

        data.forEach(function(item, key) {

            items += `<option value="${item.owner_id}">${item.owner_name}</option>`

        })
        $('#building').html(items);

    }, function(errorMsg) {
        // alert("请求数据失败!");
    }, 2)
};

//日期筛选
layui.use('laydate', function() {
    var laydate = layui.laydate;
    ///年月选择器
    laydate.render({
        elem: '#chooseTime',
        type: 'month',
        max: -30, //7天后
        trigger: 'click', //呼出事件改成click
        done: function(value, date, endDate) {
            setTimeout(function() {
                getListData(getSearchParamObj());
            }, 100)
        }

    });

});

//建筑筛选
$("#building").change(function() {
    setTimeout(function() {
        getListData(getSearchParamObj());
    }, 100)

});

// 数据请求传参
getListData(getSearchParamObj());

function getListData(queryParam = {}) {

    ajaxRequest(ELE_FIRE_DATA, "POST", queryParam, function(result) {

        if (result.totalCount != 0) {

            /* 
                 主页面数据对接 start
            */

            //数据统计
            var data_statistics = result.RESULT[0].data_statistics;
            $('.total').html(data_statistics.alarm_number);
            $('.solved').html(data_statistics.processing_number);
            $('.unsolve').html(data_statistics.unprocessed_number);

            // 环状饼图定制 （数据统计计算）
            (function() {
                // 实例化对象
                var myChart = echarts.init(document.querySelector(".bar-3d .chart"));

                // 生成扇形的曲面参数方程，用于 series-surface.parametricEquation
                function getParametricEquation(startRatio, endRatio, isSelected, isHovered, k, height) {

                    // 计算
                    let midRatio = (startRatio + endRatio) / 2;

                    let startRadian = startRatio * Math.PI * 2;
                    let endRadian = endRatio * Math.PI * 2;
                    let midRadian = midRatio * Math.PI * 2;

                    // 如果只有一个扇形，则不实现选中效果。
                    if (startRatio === 0 && endRatio === 1) {
                        isSelected = false;
                    }

                    // 通过扇形内径/外径的值，换算出辅助参数 k（默认值 1/3）
                    k = typeof k !== 'undefined' ? k : 1 / 3;

                    // 计算选中效果分别在 x 轴、y 轴方向上的位移（未选中，则位移均为 0）
                    let offsetX = isSelected ? Math.cos(midRadian) * 0.1 : 0;
                    let offsetY = isSelected ? Math.sin(midRadian) * 0.1 : 0;

                    // 计算高亮效果的放大比例（未高亮，则比例为 1）
                    let hoverRate = isHovered ? 1.05 : 1;

                    // 返回曲面参数方程
                    return {

                        u: {
                            min: -Math.PI,
                            max: Math.PI * 3,
                            step: Math.PI / 32
                        },

                        v: {
                            min: 0,
                            max: Math.PI * 2,
                            step: Math.PI / 20
                        },

                        x: function(u, v) {
                            if (u < startRadian) {
                                return offsetX + Math.cos(startRadian) * (1 + Math.cos(v) * k) * hoverRate;
                            }
                            if (u > endRadian) {
                                return offsetX + Math.cos(endRadian) * (1 + Math.cos(v) * k) * hoverRate;
                            }
                            return offsetX + Math.cos(u) * (1 + Math.cos(v) * k) * hoverRate;
                        },

                        y: function(u, v) {
                            if (u < startRadian) {
                                return offsetY + Math.sin(startRadian) * (1 + Math.cos(v) * k) * hoverRate;
                            }
                            if (u > endRadian) {
                                return offsetY + Math.sin(endRadian) * (1 + Math.cos(v) * k) * hoverRate;
                            }
                            return offsetY + Math.sin(u) * (1 + Math.cos(v) * k) * hoverRate;
                        },

                        z: function(u, v) {
                            if (u < -Math.PI * 0.5) {
                                return Math.sin(u);
                            }
                            if (u > Math.PI * 2.5) {
                                return Math.sin(u);
                            }
                            return Math.sin(v) > 0 ? 1 : -1;
                        }
                    };
                }

                // 生成模拟 3D 饼图的配置项
                function getPie3D(pieData, internalDiameterRatio) {

                    let series = [];
                    let sumValue = 0;
                    let startValue = 0;
                    let endValue = 0;
                    let legendData = [];
                    let k = typeof internalDiameterRatio !== 'undefined' ? (1 - internalDiameterRatio) / (1 + internalDiameterRatio) : 1 / 3;

                    // 为每一个饼图数据，生成一个 series-surface 配置
                    for (let i = 0; i < pieData.length; i++) {

                        sumValue += pieData[i].value;

                        let seriesItem = {
                            name: typeof pieData[i].name === 'undefined' ? `series${i}` : pieData[i].name,
                            type: 'surface',
                            parametric: true,
                            wireframe: {
                                show: false
                            },
                            pieData: pieData[i],
                            pieStatus: {
                                selected: false,
                                hovered: false,
                                k: k
                            }
                        };

                        if (typeof pieData[i].itemStyle != 'undefined') {

                            let itemStyle = {};

                            typeof pieData[i].itemStyle.color != 'undefined' ? itemStyle.color = pieData[i].itemStyle.color : null;
                            typeof pieData[i].itemStyle.opacity != 'undefined' ? itemStyle.opacity = pieData[i].itemStyle.opacity : null;

                            seriesItem.itemStyle = itemStyle;
                        }
                        series.push(seriesItem);
                    }

                    // 使用上一次遍历时，计算出的数据和 sumValue，调用 getParametricEquation 函数，
                    // 向每个 series-surface 传入不同的参数方程 series-surface.parametricEquation，也就是实现每一个扇形。
                    for (let i = 0; i < series.length; i++) {
                        endValue = startValue + series[i].pieData.value;
                        // console.log(series[i]);
                        series[i].pieData.startRatio = startValue / sumValue;
                        series[i].pieData.endRatio = endValue / sumValue;
                        series[i].parametricEquation = getParametricEquation(series[i].pieData.startRatio, series[i].pieData.endRatio, false, false, k, series[i].pieData.value);

                        startValue = endValue;

                        legendData.push(series[i].name);
                    }



                    // 准备待返回的配置项，把准备好的 legendData、series 传入。
                    let option = {

                        tooltip: {
                            backgroundColor: '#12DFE0',
                            formatter: params => {
                                if (params.seriesName !== 'mouseoutSeries') {
                                    // return `${params.seriesName}<br/><span style="display:inline-block;margin-right:5px;border-radius:10px;width:10px;height:10px;background-color:${params.color};"></span>${option.series[params.seriesIndex].pieData.value}%`;
                                    return `${params.seriesName}: ${option.series[params.seriesIndex].pieData.value}%`;
                                }
                            }
                        },

                        xAxis3D: {
                            min: -1,
                            max: 1
                        },
                        yAxis3D: {
                            min: -1,
                            max: 1
                        },
                        zAxis3D: {
                            min: -1,
                            max: 1
                        },
                        grid3D: {


                            show: false,
                            boxHeight: 40,
                            top: '-10%',
                            // bottom: '80%',
                            // environment: '../images/3d-bg.png', //aa背景色

                            viewControl: {
                                distance: 170, //aa距离
                                alpha: 21, //aa角度
                                beta: 60, //aa角度
                                zoomSensitivity: false //是否开启缩放和平移
                            },
                        },
                        series: series
                    };
                    return option;
                }

                // 传入数据生成 option
                var option = getPie3D([{
                        name: '已处理率',
                        value: data_statistics.treatment_rate,
                        itemStyle: {
                            opacity: 0.5,
                            color: 'rgba(0,127,244,.8)',
                        }
                    }, {
                        name: '未处理率',
                        value: data_statistics.untreated_rate,
                        itemStyle: {
                            opacity: 0.5,
                            color: 'rgba(209,126,23,.8)',
                        }
                    }

                ], 2);

                // 把配置给实例对象
                myChart.setOption(option);
                window.addEventListener("resize", function() {
                    myChart.resize();
                });

            })();

            // 折线图定制 (数据离散率挖掘)
            (function() {

                let dispersion_rate = result.RESULT[0].dispersion_rate;

                // 结论数据渲染
                var items = '';
                var conclusion = dispersion_rate.conclusion
                for (x in conclusion) {
                    xIndex = x.substr(x.length - 1, 1);
                    items += `<p>${xIndex}、${conclusion[x]}</p>`
                }
                $('.divergence .summaryDetail').html(items);

                // 三相电压
                let a = [];
                let b = [];
                let c = [];
                let d = [];
                let voltage = dispersion_rate.voltage;
                voltage.forEach(function(item, index) {
                    a.push(item.variance)
                    b.push(item.standard_deviation)
                    c.push(item.average_value)
                    d.push(item.data_time)
                });

                // 三相电流
                let a2 = [];
                let b2 = [];
                let c2 = [];
                let d2 = [];
                let electric_current = dispersion_rate.electric_current;
                electric_current.forEach(function(item, index) {
                    a2.push(item.variance)
                    b2.push(item.standard_deviation)
                    c2.push(item.average_value)
                    d2.push(item.data_time)
                });

                // 三相温度
                let a3 = [];
                let b3 = [];
                let c3 = [];
                let d3 = [];
                let temperature = dispersion_rate.temperature;
                temperature.forEach(function(item, index) {
                    a3.push(item.variance)
                    b3.push(item.standard_deviation)
                    c3.push(item.average_value)
                    d3.push(item.data_time)
                });

                //  漏电电流
                let a4 = [];
                let b4 = [];
                let c4 = [];
                let d4 = [];
                let leakage_current = dispersion_rate.leakage_current;
                leakage_current.forEach(function(item, index) {
                    a4.push(item.variance)
                    b4.push(item.standard_deviation)
                    c4.push(item.average_value)
                    d4.push(item.data_time)
                });

                var sortData = [{
                        sortName: "三相电压",
                        data: [a, b, c, d]
                    },
                    {
                        sortName: "三相电流",
                        data: [a2, b2, c2, d2]
                    },
                    {
                        sortName: "三相温度",
                        data: [a3, b3, c3, d3]
                    }, {
                        sortName: "漏电电流",
                        data: [a4, b4, c4, d4]
                    },
                ];

                var xData = function() {
                    var data = [];
                    for (var i = 1; i < leakage_current.length + 1; i++) {
                        data.push(i);
                    }
                    return data;
                }();

                // 1. 实例化对象
                var myChart = echarts.init(document.querySelector(".divergence .chart"));
                // 2.指定配置
                var option = {

                    color: [{
                            colorStops: [{
                                offset: 0,
                                color: '#F9860C' // 0% 处的颜色
                            }, {
                                offset: 1,
                                color: '#fff' // 100% 处的颜色
                            }],
                        },

                        {

                            colorStops: [{
                                offset: 0,
                                color: '#07E1F1' // 0% 处的颜色
                            }, {
                                offset: 1,
                                color: '#0456CB' // 100% 处的颜色
                            }],

                        },

                        {

                            colorStops: [{
                                offset: 0,
                                color: '#11F90C' // 0% 处的颜色
                            }, {
                                offset: 1,
                                color: '#3FC713' // 100% 处的颜色
                            }],

                        }

                    ],
                    tooltip: {
                        trigger: "axis",
                        textStyle: {
                            align: 'left' //图例左对齐
                        },
                        backgroundColor: '#12DFE0',
                        formatter: '{a0}: {c0}<br />{a1}: {c1}<br />{a2}: {c2}<br />时间：{b}'
                    },
                    legend: {
                        // 如果series 对象有name 值，则 legend可以不用写data
                        itemGap: 20,
                        itemHeight: 2,
                        itemWidth: 15,
                        icon: 'rect',
                        textStyle: {
                            color: "#fff"
                        },
                        top: "bottom",
