/*
 * arch/arm/mach-pxa/include/mach/mfp-pxa300.h
 *
 * PXA300/PXA310 specific MFP configuration definitions
 *
 * Copyright (C) 2007 Marvell International Ltd.
 * 2007-08-21: eric miao <eric.miao@marvell.com>
 *             initial version
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation.
 */

#ifndef __ASM_ARCH_MFP_PXA300_H
#define __ASM_ARCH_MFP_PXA300_H

#include <mach/mfp-pxa3xx.h>

/* GPIO */
#define GPIO46_GPIO		MFP_CFG(GPIO46, AF1)
#define GPIO49_GPIO		MFP_CFG(GPIO49, AF3)
#define GPIO50_GPIO		MFP_CFG(GPIO50, AF2)
#define GPIO51_GPIO		MFP_CFG(GPIO51, AF3)
#define GPIO52_GPIO		MFP_CFG(GPIO52, AF3)
#define GPIO56_GPIO		MFP_CFG(GPIO56, AF0)
#define GPIO58_GPIO		MFP_CFG(GPIO58, AF0)
#define GPIO59_GPIO		MFP_CFG(GPIO59, AF0)
#define GPIO60_GPIO		MFP_CFG(GPIO60, AF0)
#define GPIO61_GPIO		MFP_CFG(GPIO61, AF0)
#define GPIO62_GPIO		MFP_CFG(GPIO62, AF0)

#ifdef CONFIG_CPU_PXA310
#define GPIO7_2_GPIO		MFP_CFG(GPIO7_2, AF0)
#define GPIO8_2_GPIO		MFP_CFG(GPIO8_2, AF0)
#define GPIO9_2_GPIO		MFP_CFG(GPIO9_2, AF0)
#define GPIO10_2_GPIO		MFP_CFG(GPIO10_2, AF0)
#define GPIO11_2_GPIO		MFP_CFG(GPIO11_2, AF0)
#define GPIO12_2_GPIO		MFP_CFG(GPIO12_2, AF0)
#endif

/* Chip Select */
#define GPIO1_nCS2		MFP_CFG(GPIO1,	AF1)
#define GPIO2_nCS3		MFP_CFG(GPIO2,  AF1)

/* AC97 */
#define GPIO23_AC97_nACRESET	MFP_CFG(GPIO23, AF1)
#define GPIO24_AC97_SYSCLK	MFP_CFG(GPIO24, AF1)
#define GPIO29_AC97_BITCLK	MFP_CFG(GPIO29, AF1)
#define GPIO25_AC97_SDATA_IN_0	MFP_CFG(GPIO25, AF1)
#define GPIO26_AC97_SDATA_IN_1	MFP_CFG(GPIO26, AF1)
#define GPIO17_AC97_SDATA_IN_2	MFP_CFG(GPIO17, AF3)
#define GPIO21_AC97_SDATA_IN_2	MFP_CFG(GPIO21, AF2)
#define GPIO18_AC97_SDATA_IN_3	MFP_CFG(GPIO18, AF3)
#define GPIO22_AC97_SDATA_IN_3	MFP_CFG(GPIO22, AF2)
#define GPIO27_AC97_SDATA_OUT	MFP_CFG(GPIO27, AF1)
#define GPIO28_AC97_SYNC	MFP_CFG(GPIO28, AF1)

/* I2C */
#define GPIO21_I2C_SCL		MFP_CFG_LPM(GPIO21, AF1, PULL_HIGH)
#define GPIO22_I2C_SDA		MFP_CFG_LPM(GPIO22, AF1, PULL_HIGH)

/* QCI */
#define GPIO39_CI_DD_0		MFP_CFG_DRV(GPIO39, AF1, DS04X)
#define GPIO40_CI_DD_1		MFP_CFG_DRV(GPIO40, AF1, DS04X)
#define GPIO41_CI_DD_2		MFP_CFG_DRV(GPIO41, AF1, DS04X)
#define GPIO42_CI_DD_3		MFP_CFG_DRV(GPIO42, AF1, DS04X)
#define GPIO43_CI_DD_4		MFP_CFG_DRV(GPIO43, AF1, DS04X)
#define GPIO44_CI_DD_5		MFP_CFG_DRV(GPIO44, AF1, DS04X)
#define GPIO45_CI_DD_6		MFP_CFG_DRV(GPIO45, AF1, DS04X)
#define GPIO46_CI_DD_7		MFP_CFG_DRV(GPIO46, AF0, DS04X)
#define GPIO47_CI_DD_8		MFP_CFG_DRV(GPIO47, AF1, DS04X)
#define GPIO48_CI_DD_9		MFP_CFG_DRV(GPIO48, AF1, DS04X)
#define GPIO49_CI_MCLK		MFP_CFG_DRV(GPIO49, AF0, DS04X)
#define GPIO50_CI_PCLK		MFP_CFG_DRV(GPIO50, AF0, DS04X)
#define GPIO51_CI_HSYNC		MFP_CFG_DRV(GPIO51, AF0, DS04X)
#define GPIO52_CI_VSYNC		MFP_CFG_DRV(GPIO52, AF0, DS04X)

/* KEYPAD */
#define GPIO3_KP_DKIN_6		MFP_CFG_LPM(GPIO3,   AF2, FLOAT)
#define GPIO4_KP_DKIN_7		MFP_CFG_LPM(GPIO4,   AF2, FLOAT)
#define GPIO16_KP_DKIN_6	MFP_CFG_LPM(GPIO16,  AF6, FLOAT)
#define GPIO83_KP_DKIN_2	MFP_CFG_LPM(GPIO83,  AF5, FLOAT)
#define GPIO84_KP_DKIN_1	MFP_CFG_LPM(GPIO84,  AF5, FLOAT)
#define GPIO85_KP_DKIN_0	MFP_CFG_LPM(GPIO85,  AF3, FLOAT)
#define GPIO86_KP_DKIN_1	MFP_CFG_LPM(GPIO86,  AF3, FLOAT)
#define GPIO87_KP_DKIN_2	MFP_CFG_LPM(GPIO87,  AF3, FLOAT)
#define GPIO88_KP_DKIN_3	MFP_CFG_LPM(GPIO88,  AF3, FLOAT)
#define GPIO89_KP_DKIN_3	MFP_CFG_LPM(GPIO89,  AF3, FLOAT)
#define GPIO107_KP_DKIN_0	MFP_CFG_LPM(GPIO107, AF2, FLOAT)
#define GPIO108_KP_DKIN_1	MFP_CFG_LPM(GPIO108, AF2, FLOAT)
#define GPIO109_KP_DKIN_2	MFP_CFG_LPM(GPIO109, AF2, FLOAT)
#define GPIO110_KP_DKIN_3	MFP_CFG_LPM(GPIO110, AF2, FLOAT)
#define GPIO111_KP_DKIN_4	MFP_CFG_LPM(GPIO111, AF2, FLOAT)
#define GPIO112_KP_DKIN_5	MFP_CFG_LPM(GPIO112, AF2, FLOAT)
#define GPIO113_KP_DKIN_6	MFP_CFG_LPM(GPIO113, AF2, FLOAT)
#define GPIO114_KP_DKIN_7	MFP_CFG_LPM(GPIO114, AF2, FLOAT)
#define GPIO115_KP_DKIN_0	MFP_CFG_LPM(GPIO115, AF2, FLOAT)
#define GPIO116_KP_DKIN_1	MFP_CFG_LPM(GPIO116, AF2, FLOAT)
#define GPIO117_KP_DKIN_2	MFP_CFG_LPM(GPIO117, AF2, FLOAT)
#define GPIO118_KP_DKIN_3	MFP_CFG_LPM(GPIO118, AF2, FLOAT)
#define GPIO119_KP_DKIN_4	MFP_CFG_LPM(GPIO119, AF2, FLOAT)
#define GPIO120_KP_DKIN_5	MFP_CFG_LPM(GPIO120, AF2, FLOAT)
#define GPIO121_KP_DKIN_6	MFP_CFG_LPM(GPIO121, AF2, FLOAT)
#define GPIO122_KP_DKIN_5	MFP_CFG_LPM(GPIO122, AF2, FLOAT)
#define GPIO123_KP_DKIN_4	MFP_CFG_LPM(GPIO123, AF2, FLOAT)
#define GPIO124_KP_DKIN_3	MFP_CFG_LPM(GPIO124, AF2, FLOAT)
#define GPIO127_KP_DKIN_0	MFP_CFG_LPM(GPIO127, AF5, FLOAT)
