/*
 * OMAP44xx ES1.0 pin mux definition
 *
 * Copyright (C) 2010 Texas Instruments, Inc.
 *
 * Benoit Cousson (b-cousson@ti.com)
 *
 * - Based on mux34xx.c done by Tony Lindgren <tony@atomide.com>
 *
 * This file is automatically generated from the OMAP hardware databases.
 * We respectfully ask that any modifications to this file be coordinated
 * with the public linux-omap@vger.kernel.org mailing list and the
 * authors above to ensure that the autogeneration scripts are kept
 * up-to-date with the file contents.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
#include <linux/module.h>
#include <linux/init.h>

#include "mux.h"

#ifdef CONFIG_OMAP_MUX

#define _OMAP4_MUXENTRY(M0, g, m0, m1, m2, m3, m4, m5, m6, m7)	\
{									\
	.reg_offset	= (OMAP4_CTRL_MODULE_PAD_##M0##_OFFSET),	\
	.gpio		= (g),						\
	.muxnames	= { m0, m1, m2, m3, m4, m5, m6, m7 },		\
}

#else

#define _OMAP4_MUXENTRY(M0, g, m0, m1, m2, m3, m4, m5, m6, m7)	\
{									\
	.reg_offset	= (OMAP4_CTRL_MODULE_PAD_##M0##_OFFSET),	\
	.gpio		= (g),						\
}

#endif

#define _OMAP4_BALLENTRY(M0, bb, bt)				\
{									\
	.reg_offset	= (OMAP4_CTRL_MODULE_PAD_##M0##_OFFSET),	\
	.balls		= { bb, bt },					\
}

/*
 * Superset of all mux modes for omap4 ES1.0
 */
static struct omap_mux __initdata omap4_core_muxmodes[] = {
	_OMAP4_MUXENTRY(GPMC_AD0, 0, "gpmc_ad0", "sdmmc2_dat0", NULL, NULL,
			NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_AD1, 0, "gpmc_ad1", "sdmmc2_dat1", NULL, NULL,
			NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_AD2, 0, "gpmc_ad2", "sdmmc2_dat2", NULL, NULL,
			NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_AD3, 0, "gpmc_ad3", "sdmmc2_dat3", NULL, NULL,
			NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_AD4, 0, "gpmc_ad4", "sdmmc2_dat4",
			"sdmmc2_dir_dat0", NULL, NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_AD5, 0, "gpmc_ad5", "sdmmc2_dat5",
			"sdmmc2_dir_dat1", NULL, NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_AD6, 0, "gpmc_ad6", "sdmmc2_dat6",
			"sdmmc2_dir_cmd", NULL, NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_AD7, 0, "gpmc_ad7", "sdmmc2_dat7",
			"sdmmc2_clk_fdbk", NULL, NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_AD8, 32, "gpmc_ad8", "kpd_row0", "c2c_data15",
			"gpio_32", NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_AD9, 33, "gpmc_ad9", "kpd_row1", "c2c_data14",
			"gpio_33", NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_AD10, 34, "gpmc_ad10", "kpd_row2", "c2c_data13",
			"gpio_34", NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_AD11, 35, "gpmc_ad11", "kpd_row3", "c2c_data12",
			"gpio_35", NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_AD12, 36, "gpmc_ad12", "kpd_col0", "c2c_data11",
			"gpio_36", NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_AD13, 37, "gpmc_ad13", "kpd_col1", "c2c_data10",
			"gpio_37", NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_AD14, 38, "gpmc_ad14", "kpd_col2", "c2c_data9",
			"gpio_38", NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_AD15, 39, "gpmc_ad15", "kpd_col3", "c2c_data8",
			"gpio_39", NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_A16, 40, "gpmc_a16", "kpd_row4", "c2c_datain0",
			"gpio_40", "venc_656_data0", NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_A17, 41, "gpmc_a17", "kpd_row5", "c2c_datain1",
			"gpio_41", "venc_656_data1", NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(GPMC_A18, 42, "gpmc_a18", "kpd_row6", "c2c_datain2",
			"gpio_42", "venc_656_data2", NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(GPMC_A19, 43, "gpmc_a19", "kpd_row7", "c2c_datain3",
			"gpio_43", "venc_656_data3", NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(GPMC_A20, 44, "gpmc_a20", "kpd_col4", "c2c_datain4",
			"gpio_44", "venc_656_data4", NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(GPMC_A21, 45, "gpmc_a21", "kpd_col5", "c2c_datain5",
			"gpio_45", "venc_656_data5", NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(GPMC_A22, 46, "gpmc_a22", "kpd_col6", "c2c_datain6",
			"gpio_46", "venc_656_data6", NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(GPMC_A23, 47, "gpmc_a23", "kpd_col7", "c2c_datain7",
			"gpio_47", "venc_656_data7", NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(GPMC_A24, 48, "gpmc_a24", NULL, "c2c_clkout0",
			"gpio_48", NULL, NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(GPMC_A25, 49, "gpmc_a25", NULL, "c2c_clkout1",
			"gpio_49", NULL, NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(GPMC_NCS0, 50, "gpmc_ncs0", NULL, NULL, "gpio_50",
			"sys_ndmareq0", NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_NCS1, 51, "gpmc_ncs1", NULL, "c2c_dataout6",
			"gpio_51", NULL, NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(GPMC_NCS2, 52, "gpmc_ncs2", NULL, "c2c_dataout7",
			"gpio_52", NULL, NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(GPMC_NCS3, 53, "gpmc_ncs3", "gpmc_dir",
			"c2c_dataout4", "gpio_53", NULL, NULL, NULL,
			"safe_mode"),
	_OMAP4_MUXENTRY(GPMC_NWP, 54, "gpmc_nwp", "dsi1_te0", NULL, "gpio_54",
			"sys_ndmareq1", NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_CLK, 55, "gpmc_clk", NULL, NULL, "gpio_55",
			"sys_ndmareq2", NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_NADV_ALE, 56, "gpmc_nadv_ale", "dsi1_te1", NULL,
			"gpio_56", "sys_ndmareq3", NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_NOE, 0, "gpmc_noe", "sdmmc2_clk", NULL, NULL,
			NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_NWE, 0, "gpmc_nwe", "sdmmc2_cmd", NULL, NULL,
			NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_NBE0_CLE, 59, "gpmc_nbe0_cle", "dsi2_te0", NULL,
			"gpio_59", NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_NBE1, 60, "gpmc_nbe1", NULL, "c2c_dataout5",
			"gpio_60", NULL, NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(GPMC_WAIT0, 61, "gpmc_wait0", "dsi2_te1", NULL,
			"gpio_61", NULL, NULL, NULL, NULL),
	_OMAP4_MUXENTRY(GPMC_WAIT1, 62, "gpmc_wait1", NULL, "c2c_dataout2",
			"gpio_62", NULL, NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(C2C_DATA11, 100, "c2c_data11", "usbc1_icusb_txen",
			"c2c_dataout3", "gpio_100", "sys_ndmareq0", NULL,
			NULL, "safe_mode"),
	_OMAP4_MUXENTRY(C2C_DATA12, 101, "c2c_data12", "dsi1_te0",
			"c2c_clkin0", "gpio_101", "sys_ndmareq1", NULL, NULL,
			"safe_mode"),
	_OMAP4_MUXENTRY(C2C_DATA13, 102, "c2c_data13", "dsi1_te1",
			"c2c_clkin1", "gpio_102", "sys_ndmareq2", NULL, NULL,
			"safe_mode"),
	_OMAP4_MUXENTRY(C2C_DATA14, 103, "c2c_data14", "dsi2_te0",
			"c2c_dataout0", "gpio_103", "sys_ndmareq3", NULL,
			NULL, "safe_mode"),
	_OMAP4_MUXENTRY(C2C_DATA15, 104, "c2c_data15", "dsi2_te1",
			"c2c_dataout1", "gpio_104", NULL, NULL, NULL,
			"safe_mode"),
	_OMAP4_MUXENTRY(HDMI_HPD, 63, "hdmi_hpd", NULL, NULL, "gpio_63", NULL,
			NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(HDMI_CEC, 64, "hdmi_cec", NULL, NULL, "gpio_64", NULL,
			NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(HDMI_DDC_SCL, 65, "hdmi_ddc_scl", NULL, NULL,
			"gpio_65", NULL, NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(HDMI_DDC_SDA, 66, "hdmi_ddc_sda", NULL, NULL,
			"gpio_66", NULL, NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(CSI21_DX0, 0, "csi21_dx0", NULL, NULL, "gpi_67", NULL,
			NULL, NULL, "safe_mode"),
	_OMAP4_MUXENTRY(CSI21_DY0, 0, "csi21_dy0", NULL, NULL, "gpi_68", NULL,
			NULL, NULL, "safe_mode"),
